#include "icmp.h"

void
monitor(int resolve, int seq, int echo, char *intf)
{
	int fd = 0, is_ppp = 0, pppframe = 0;
	struct ip *ip;
	struct icmp *icmp;
	char buf[10000];
	char *s1 = NULL, *s2 = NULL;

	/* use PACKET layer to access ICMP packets */
	if ((fd = socket(PF_INET, SOCK_PACKET, htons(ETH_P_ALL))) < 0) {
           	perror("socket");
                exit(errno);
        }
	if (strstr(intf, "ppp"))
		is_ppp++;
		
        setpromisc(fd, intf);
        promisc = fd;
        printf("monitoring ICMP traffic:\n");
	while (1) {
           	bzero(buf,10000);
                if (read(fd, buf, 9999) < 0)  {
			perror("read");
			exit(errno);
		}
                if (is_ppp)
                   	pppframe = 4+2-sizeof(struct ethhdr);
		ip = (struct ip*)(buf + sizeof(struct ethhdr) + pppframe);
               	icmp = (struct icmp*)(buf + sizeof(struct ethhdr) + pppframe + (ip->ip_hl<<2));
                
                /* skip all wich is not ICMPv4 */
                if (ip->ip_p != ICMPv4)
                   	continue;
                /* skip echo_request/reply if wanted */
                if (!echo && (icmp->icmp_type == 0 || icmp->icmp_type == 8))
                       	continue;
                bounds_check(&icmp->icmp_type, &icmp->icmp_code);
           	
                /* resolve to hostnames if resolve == 1 */
		s1 = resolv(ip->ip_src, resolve);
		s2 = resolv(ip->ip_dst, resolve);
                printf("%s -> %s (IPv%d) was '%s' ", s1, s2,
                        ip->ip_v, msg[icmp->icmp_type][icmp->icmp_code]);
		free(s1); 
		free(s2);
                if (seq) 
                   	printf("[%d]\n", icmp->icmp_seq);
                else
                   	printf("\n");
                fflush(stdout);
	} /* while */
	return;
}
